@echo off

color 0A

title Embedded Wizard Build Environment for STM32F746 Discovery

setlocal enableextensions
       
       
set ST-LINK_Utility_Path=C:\Program Files (x86)\STMicroelectronics\STM32 ST-LINK Utility\ST-LINK Utility
set STLINK_EXT_FLASH_LOADER="%ST-LINK_Utility_Path%/ExternalLoader/N25Q128A_STM32F746G-DISCO.stldr"

set Toolchain_Path=..\..\gcc-arm-none-eabi\bin
set STM32Cube_Path=STM32Cube_FW_F7
         
IF DEFINED BuildInitialized GOTO run

GOTO setpaths

:setpaths

:: set the path to make and its tools
set PATH=%~dp0;%PATH%
set PATH=%~dp0\Make;%PATH%

:: compiler path
set PATH=%~dp0%Toolchain_Path%;%PATH%

:: st-link utility path
set PATH=%ST-LINK_Utility_Path%;%PATH%

set BuildInitialized=1

:run

REM do some checks
if not exist "%ST-LINK_Utility_Path%" (
  echo. 
  echo ST-LINK_Utility check failed:
  echo ST-LINK_Utility not found on path:
  echo "%ST-LINK_Utility_Path%".
  echo Please install the ST-LINK_Utility or adapt the path in 'Build\devenv.cmd'.
  echo. 
)

if not exist "%~dp0%Toolchain_Path%" (
  echo. 
  echo Toolchain check failed:
  echo The ARM GCC toolchain was not found on the expected path: 
  echo '%~dp0%Toolchain_Path%'.
  echo Please install the ARM GCC toolchain to this folder [please refer to ReadMe.txt]
  echo or adapt the toolchain path in 'Build\devenv.cmd'.  
  echo. 
)

if not exist "%~dp0..\..\%STM32Cube_Path%" (
  echo. 
  echo STM32Cube check failed:
  echo The STM32Cube package was not found on the expected path: 
  echo '%~dp0..\..\%STM32Cube_Path%'.
  echo Please install the STM32Cube package to this folder [Please refer to ReadMe.txt]
  echo or adapt the STM32Cube path in 'Build\devenv.cmd'.  
  echo. 
)



cd ..\Examples

:: set the compiler environment variables
cmd /k gccvar.bat
